package com.nisum.example.webflux.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.*;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

/**
 * Model class for Book
 * Having fields bookId, bookName, bookAuthor, bookPrice
 */
@Data
@NoArgsConstructor
@RequiredArgsConstructor
@Document
public class Book {

    @Id
    @Field("_id")
    @JsonIgnore
    private String id;

    @Field("bookId")
    @NonNull
    private Long bookId;
    @NonNull
    private String bookName;
    @NonNull
    private String bookAuthor;
    @NonNull
    private Long bookPrice;
}
