package com.nisum.example.webflux.service;

import com.nisum.example.webflux.model.Book;
import com.nisum.example.webflux.repository.BookRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;

import java.util.List;

/**
 * Service class having method to insert record into db
 */
@Service
public class BookServiceImpl implements BookService {

    @Autowired
    private BookRepository bookRepository;

    /**
     * method to insert records in db
     * @param books
     * @return Flux<T>
     */
    @Override
    public Flux<Book> insertBook(List<Book> books) {
        return bookRepository.saveAll(books);
    }
}
